# Global Search

## [v0.22.0](https://github.com/Oppzippy/GlobalSearch/tree/v0.22.0) (2023-06-25)
[Full Changelog](https://github.com/Oppzippy/GlobalSearch/compare/v0.21.2...v0.22.0) [Previous Releases](https://github.com/Oppzippy/GlobalSearch/releases)

- Add option for preload cache delay  
- ToysSearchProvider: fix waiting too long and toy names becomnig nil again  
    Toy names are only guaranteed to not be nil exactly when the last  
    TOYS\_UPDATED fires. The debounce was retrieving items a second later  
    than that, so toys were nil again. The solution is to retrieve the  
    latest items on every TOYS\_UPDATED, but not set them via  
    GlobalSearch\_ProviderItemsUpdated message until the debounce.  
- ToysSearchProvider: debounce toy updates rather than throttle  
    See 913507bbda57d8bdae1bd3e75c917c82b96eda88 commit message for more  
    detail.  
- Revert "ToysSearchProvider: fix toys failing to load under high load"  
    The reverted commit was ineffective in fixing the issue.  
    I did some more investigation and found the mistakes in my previous  
    approaches.  
    The first attempt refers to the state after reverting this commit. The  
    second attempt refers to the state before reverting this commit.  
    My first attempt used a throttle on TOYS\_UPDATED since I was under  
    the impression that the event would fire a maximum of two times, and  
    both events would be in quick succession. Turns out that's false,  
    TOYS\_UPDATED fires in rapid succession from the point that the toy  
    filter is changed until the point that all toys are loaded. If you  
    spam transmog functions, this event will keep spamming until the  
    transmog functions stop.  
    My second attempt was more focused on toy names being nil, so I  
    essentially just kept checking every second if any of the toy names are  
    nil. If not, and the number of toys available is the same as the number  
    of toys available a second ago, we are done. Turns out it will quickly  
    load around 30-60% of the toys depending on how hard I spam transmog  
    functions, return non-nil names for those toys, and then stop loading  
    any more toys until the transmog functions stop. Despite not loading  
    any more toys for this period of time, TOYS\_UPDATED is still repeatedly  
    fired.  
    Looks like all I need to do is go back to something like the first  
    solution, but with a debounce rather than throttle.  
- ToysSearchProvider: fix toys failing to load under high load  
    When transmog related functions are called too much, the toys ones stop  
    working.  
    4deac9dfcd557bb29912d8774c5080d9ce22c2c1 fixed this when the transmog  
    function calls are prior to fetching toys, however it did not cover when  
    transmog functions are being continuously spam called.  
- Remove unused variable  
- ToysSearchProvider: don't clear cache if old and new item lists match  
- Fix conflict with transmog addons (GH-21)  
    For some reason, when another addon calls  
    C\_TransmogCollection.GetAppearanceSources, all toys get unloaded, so we  
    have to wait for TOYS\_UPDATED.  
    This is implemented by initially displaying the search without the toys,  
    and then updating the displayed items shortly after when the toys are  
    loaded.  
- AceConfigOptionsTable was renamed to AceConfig.OptionsTable  
- Add scrolling through result pages with scroll wheel  
- Add github action to update toc interface version  
